> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/api-targets/search-engines/google/scholar.md).

# Scholar

The `google_scholar` data source is designed to retrieve Google Scholar search results, including academic papers, books, citations, and related links.

## Request samples

In this example, we make a request to retrieve Google Scholar results for the query `best novels`.

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "google_scholar",
        "query": "best novels",
        "render": "html",
        "parse": true
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
  "source": "google_scholar",
  "query": "best novels",
  "render": "html",
  "parse": True
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload,
)

# Print prettified response to stdout.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "google_scholar",
    query: "best novels",
    render: "html",
    parse: true,
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://realtime.oxylabs.io/v1/queries?source=google_scholar&query=best+novels&render=html&parse=true&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'google_scholar',
    'query' => 'best novels',
    'render' => 'html',
    'parse' => true
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");


$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{}{
		"source": "google_scholar",
		"query":  "best novels",
		"render": "html",
		"parse":  true,
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "google_scholar",
                query = "best novels",
                render = "html",
                parse = true
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "google_scholar");
        jsonObject.put("query", "best novels");
        jsonObject.put("render", "html");
        jsonObject.put("parse", true);

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "google_scholar",
    "query": "best novels",
    "render": "html",
    "parse": true
}
```

{% endtab %}
{% endtabs %}

We use synchronous [**Realtime**](/products/web-scraper-api/integration-methods/realtime.md) integration method in our examples. If you would like to use [**Proxy Endpoint**](/products/web-scraper-api/integration-methods/proxy-endpoint.md) or asynchronous [**Push-Pull**](/products/web-scraper-api/integration-methods/push-pull.md) integration, refer to the [**integration methods**](/products/web-scraper-api/integration-methods.md) section.

### Request parameters

<table><thead><tr><th width="157.5">Parameter</th><th width="452">Description</th><th>Default Value</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark> </td><td>Sets the scraper. Use <code>google_scholar</code>.</td><td>–</td></tr><tr><td><mark style="background-color:green;"><strong><code>query</code></strong></mark> </td><td>Search term for the request.</td><td>–</td></tr><tr><td><mark style="background-color:green;"><strong><code>render</code></strong></mark> </td><td>Enables JavaScript rendering when set to <code>html</code>.  <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/pGs7q0aw7gpLmDsoGTdt#javascript-rendering"><strong>More info</strong></a><strong>.</strong></td><td>–</td></tr><tr><td><code>parse</code></td><td>Returns parsed data when set to <code>true</code>. See more in <a href="#output-dictionary"><strong>output dictionary</strong></a>.</td><td><code>false</code></td></tr><tr><td><code>callback_url</code></td><td>URL to your callback endpoint. <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/DijMC0XcEbNczNgRaHIV"><strong>More info</strong></a><strong>.</strong></td><td>–</td></tr><tr><td><code>user_agent_type</code></td><td>Device type and browser. The full list can be found <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/rrKXR4LNzotP94phU1YL"><strong>here</strong></a>.</td><td><code>desktop</code></td></tr></tbody></table>

&#x20;   – mandatory parameter

## Structured data

Web Scraper API can extract results HTML or JSON response that contains structured data on various elements of the results page.

<details>

<summary>Structured google_scholar output</summary>

```json
{
    "results": [
        {
            "content": {
                "organic": [
                    {
                        "description": "… and exciting as any other for the novel. The mass market paperback came into … book. Its purpose is to celebrate the writers we have loved best, and to proselytize on behalf of their novels…",
                        "inline_links": {
                            "cite_url": "https://scholar.google.com/scholar?q=info:Av0ZOt0npBEJ:scholar.google.com/&output=cite&scirp=0&hl=en",
                            "cited_by": {
                                "cites_id": "1271184825941359874",
                                "total": 15,
                                "url": "https://scholar.google.com/scholar?cites=1271184825941359874&as_sdt=2005&sciodt=0,5&hl=en"
                            },
                            "related_pages_url": "https://scholar.google.com/scholar?q=related:Av0ZOt0npBEJ:scholar.google.com/&scioq=best+novels&hl=en&as_sdt=0,5",
                            "versions": {
                                "cluster_id": "1271184825941359874",
                                "total": 5,
                                "url": "https://scholar.google.com/scholar?cluster=1271184825941359874&hl=en&as_sdt=0,5"
                            }
                        },
                        "pos": 1,
                        "publication_info": {
                            "summary": "C Callil, C Tóibín - 2011 - books.google.com"
                        },
                        "result_id": "Av0ZOt0npBEJ",
                        "result_type": "book",
                        "title": "The Modern Library: The 200 Best Novels in English Since 1950",
                        "url": "https://books.google.com/books?hl=en&lr=&id=EwlNDwAAQBAJ&oi=fnd&pg=PA1903&dq=best+novels&ots=Uiru4xYAcj&sig=exuKH7sr8Y4rAx7cvn15h8lA39Y"
                    },
                    {
                        "description": "… Predicting success of novels and movies: To the best of our knowledge, our work is the first that provides quantitative insights into the unstudied connection between the writing style …",
                        "inline_links": {
                            "cite_url": "https://scholar.google.com/scholar?q=info:r_g8gsmjLJgJ:scholar.google.com/&output=cite&scirp=4&hl=en",
                            "cited_by": {
                                "cites_id": "10965319278609103023",
                                "total": 182,
                                "url": "https://scholar.google.com/scholar?cites=10965319278609103023&as_sdt=2005&sciodt=0,5&hl=en"
                            },
                            "related_pages_url": "https://scholar.google.com/scholar?q=related:r_g8gsmjLJgJ:scholar.google.com/&scioq=best+novels&hl=en&as_sdt=0,5",
                            "versions": {
                                "cluster_id": "10965319278609103023",
                                "total": 10,
                                "url": "https://scholar.google.com/scholar?cluster=10965319278609103023&hl=en&as_sdt=0,5"
                            }
                        },
                        "pos": 5,
                        "publication_info": {
                            "authors": [
                                {
                                    "author_id": "Of8dNP0AAAAJ",
                                    "name": "VG Ashok",
                                    "url": "https://scholar.google.com/citations?user=Of8dNP0AAAAJ&hl=en&oi=sra"
                                },
                                {
                                    "author_id": "aWmHP7IAAAAJ",
                                    "name": "S Feng",
                                    "url": "https://scholar.google.com/citations?user=aWmHP7IAAAAJ&hl=en&oi=sra"
                                },
                                {
                                    "author_id": "vhP-tlcAAAAJ",
                                    "name": "Y Choi",
                                    "url": "https://scholar.google.com/citations?user=vhP-tlcAAAAJ&hl=en&oi=sra"
                                }
                            ],
                            "summary": "VG Ashok, S Feng, Y Choi - … of the 2013 conference on empirical …, 2013 - aclanthology.org"
                        },
                        "resources": [
                            {
                                "file_format": "PDF",
                                "title": "aclanthology.org",
                                "url": "https://aclanthology.org/D13-1181.pdf"
                            }
                        ],
                        "result_id": "r_g8gsmjLJgJ",
                        "result_type": "pdf",
                        "title": "Success with style: Using writing style to predict the success of novels",
                        "url": "https://aclanthology.org/D13-1181.pdf"
                    }
                    // ... up to 8 more organic results
                ],
                "pagination": {
                    "current_page": 1,
                    "next_page": "https://scholar.google.com/scholar?start=10&q=best+novels&hl=en&as_sdt=0,5",
                    "other_pages": {
                        "2": "https://scholar.google.com/scholar?start=10&q=best+novels&hl=en&as_sdt=0,5",
                        "3": "https://scholar.google.com/scholar?start=20&q=best+novels&hl=en&as_sdt=0,5"
                        // ... more page links
                    }
                },
                "parse_status_code": 12000,
                "related_searches": [
                    {
                        "query": "best novels modern library",
                        "url": "https://scholar.google.com/scholar?hl=en&as_sdt=0,5&qsp=1&q=best+novels+modern+library&qst=ib"
                    },
                    {
                        "query": "best novels short stories",
                        "url": "https://scholar.google.com/scholar?hl=en&as_sdt=0,5&qsp=2&q=best+novels+short+stories&qst=ib"
                    }
                    // ... more related searches
                ],
                "search_information": {
                    "query_displayed": "best novels",
                    "time_taken_displayed": 0.15,
                    "total_results_count": 3580000
                }
            },
            "created_at": "2026-07-18 14:00:27",
            "job_id": "7484245708602621953",
            "page": 1,
            "status_code": 200,
            "updated_at": "2026-07-18 14:00:40",
            "url": "https://scholar.google.com/scholar?q=best+novels&hl=en&gl=us"
        }
    ]
}
```

</details>

### Output dictionary

The table below presents a detailed list of each top-level element we parse, along with its description and data type.

{% hint style="info" %}
The number of organic results and certain fields may vary depending on the search query and result type.
{% endhint %}

<table><thead><tr><th width="189.5">Key</th><th width="459.5">Description</th><th width="95">Type</th></tr></thead><tbody><tr><td><code>url</code></td><td>URL to the Google Scholar search results page.</td><td>string</td></tr><tr><td><code>page</code></td><td>Current page number of the search results.</td><td>integer</td></tr><tr><td><code>parse_status_code</code></td><td>The status code of the parsing job. Learn more <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/PpAgJ3odBUGijPxHsnTV#parsers"><strong>here</strong></a>.</td><td>integer</td></tr><tr><td><code>organic</code></td><td>List of organic search results. Includes <code>pos</code>, <code>title</code>, <code>url</code>, <code>description</code>, <code>result_id</code>, <code>result_type</code>, <code>publication_info</code>, <code>inline_links</code>, <code>resources</code>.</td><td>array</td></tr><tr><td><code>organic.result_type</code></td><td>Identifies the format of the result (<code>book</code>, <code>pdf</code>, etc.). Omitted when the result is a standard article.</td><td>string</td></tr><tr><td><code>organic.publication_info</code></td><td>Summary of the publication. Includes <code>summary</code> (authors, year, publisher/source as a single string) and, when available, a structured <code>authors</code> list with <code>author_id</code>, <code>name</code>, and profile <code>url</code>.</td><td>object</td></tr><tr><td><code>organic.inline_links</code></td><td>Academic metadata attached to the result. Includes <code>cite_url</code>, <code>cited_by</code>, <code>related_pages_url</code>, <code>versions</code>.</td><td>object</td></tr><tr><td><code>organic.inline_links.cited_by</code></td><td>Citation data for the result. Includes <code>cites_id</code>, <code>total</code> (total citation count), and <code>url</code> (link to citing works).</td><td>object</td></tr><tr><td><code>organic.inline_links.related_pages_url</code></td><td>URL to find papers related to the result.</td><td>string</td></tr><tr><td><code>organic.inline_links.versions</code></td><td>Alternative versions/links for the same document. Includes <code>cluster_id</code>, <code>total</code>, and <code>url</code>.</td><td>object</td></tr><tr><td><code>organic.resources</code></td><td>Direct download links for accessible media, e.g. PDFs. Includes <code>file_format</code>, <code>title</code>, <code>url</code>.</td><td>array</td></tr><tr><td><code>pagination</code></td><td>Details about the current and available result pages. Includes <code>current_page</code>, <code>next_page</code>, <code>other_pages</code>.</td><td>object</td></tr><tr><td><code>related_searches</code></td><td>Google's suggested related search strings. Includes <code>query</code> and <code>url</code> for each suggestion.</td><td>array</td></tr><tr><td><code>search_information</code></td><td>General details about the search. Includes <code>query_displayed</code>, <code>time_taken_displayed</code>, <code>total_results_count</code>.</td><td>object</td></tr><tr><td><code>created_at</code></td><td>Timestamp when the scraping job was created.</td><td>timestamp</td></tr><tr><td><code>updated_at</code></td><td>Timestamp when the scraping job was finished.</td><td>timestamp</td></tr><tr><td><code>job_id</code></td><td>ID of the job associated with the scraping job.</td><td>string</td></tr><tr><td><code>status_code</code></td><td>Status code of the scraping job. Learn more <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/PpAgJ3odBUGijPxHsnTV"><strong>here</strong></a>.</td><td>integer</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.oxylabs.io/api-targets/search-engines/google/scholar.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
